package main

import (
	. "code.hoteas.com/golang/hotime"
	"code.hoteas.com/golang/hotime/dri/aliyun"
	"code.hoteas.com/golang/hotime/dri/ddsms"
	"code.hoteas.com/golang/hotime/dri/wechat"
	"code.hoteas.com/golang/hotime/example/app"
	"code.hoteas.com/golang/hotime/example/provider"
	//. "code.hoteas.com/golang/hotime/common"
	"fmt"
	"time"
)

func main() {
	date, _ := time.Parse("2006-01-02 15:04", time.Now().Format("2006-01-02")+" 14:00")
	fmt.Println(date, date.Unix())
	//fmt.Println("0123456"[1:7])
	appIns := Init("config/config.json")

	aliyun.Company.Init(appIns.Config.GetString("aliyunCode"))

	//初始化短信配置
	ddsms.DDY.Init(appIns.Config.GetString("smsKey"))
	//初始化公众号配置
	wechat.H5Program.Init(appIns.Config.GetString("wechatAppID"), appIns.Config.GetString("wechatAppSecret"))
	//初始化小程序配置
	wechat.MiniProgram.Init(appIns.Config.GetString("wechatMiniAppID"), appIns.Config.GetString("wechatMiniAppSecret"))
	//初始化小程序及公众号支付配置
	wechat.WxPay.Init(appIns.Config.GetString("wechatPayMCHID"),
		appIns.Config.GetString("wechatPaySerialNo"),
		appIns.Config.GetString("wechatPayMApiV3Key"),
		appIns.Config.GetString("wechatPayPrivateKey"))

	//用户侧访问前设置
	appIns.SetConnectListener(func(that *Context) (isFinished bool) {
		//发送短信校验

		return isFinished
	})

	//appIns.SetConnectListener(func(that *Context) (isFinished bool) {
	//
	//	return isFinished
	//})
	//appIns.Db.Action(func(db db.HoTimeDB) (isSuccess bool) {
	//	return isSuccess
	//})
	appIns.Run(Router{
		"provider": provider.Project,
		"app":      app.Project,
	})
}
